;; Lisp code to be evaluated by amb evaluator to implement utility procedures.

#lang sicp

(#%provide amb-utilities-program)

(define amb-utilities-program

  '((define (require p)
      (if (not p) (amb)))
    
    (define (an-element-of items)
      (require (not (null? items)))
      (amb (car items) (an-element-of (cdr items))))
    
    (define (an-integer-starting-from n)
      (amb n (an-integer-starting-from (+ n 1))))

    (define (distinct? items)
      (cond ((null? items) true)
            ((null? (cdr items)) true)
            ((member (car items) (cdr items)) false)
            (else (distinct? (cdr items)))))

    (define (map f l)
      (if (null? l) '()
          (cons (f (car l))
                (map f (cdr l)))))

    (define (and-map f l)
      (if (null? l) true
          (if (f (car l))
              true
              false)))

    (define (length l)
      (if (null? l)
          0
          (+ 1 (length (cdr l)))))

    (define (list-ref list k)
      (if (= k 0)
          (car list)
          (list-ref (cdr list) (- k 1))))

    ;; Remove the kth element from list
    (define (remove list k)
      (if (= k 0)
          (cdr list)
          (cons (car list)
                (remove (cdr list) (- k 1)))))
    ))

